Index: binaries/data/mods/public/maps/random/rmgen/wall_builder.js
===================================================================
--- binaries/data/mods/public/maps/random/rmgen/wall_builder.js
+++ binaries/data/mods/public/maps/random/rmgen/wall_builder.js
@@ -395,27 +418,31 @@ function getCenterToFirstElement(alignment)
 //  getWallLength
 //
 //	NOTE: Does not support bending wall elements like corners!
-//	e.g. used by placeIrregularPolygonalWall
 //////////////////////////////////////////////////////////////////
-function getWallLength(wall, style)
+function getWallLength(style, wall=[])
 {
 	// Graciously handle arguments
-	if (wall === undefined)
-		wall = [];
-	if (!wallStyles.hasOwnProperty(style))
+	if (g_WallStyleList.indexOf(style) < 0)
 	{
-		warn("Function getWallLength: Unknown style: " + style + ' (falling back to "athen")');
-		style = "athen";
+		warn("getWallLength: Unknown style: '" + style + "'. (Falling back to '" + FALLBACK_CIV + "_stone').");
+		style = FALLBACK_CIV +"_stone";
 	}
-	
+
 	var length = 0;
-	for (var i = 0; i < wall.length; i++)
-	{
-		length += wallStyles[style][wall[i]].width;
-	}
+	var overlap = getOverlap(style);
+	for (let element of wall)
+		length += getWallElement(style, element).length - overlap;
+
 	return length;
 }
 
+function getOverlap(style)
+{
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
+	return g_WallStyles[style]["@overlap"];
+}
+
 
 /////////////////////////////////////////////
 // Define the different wall placer functions
@@ -427,7 +454,7 @@ function getWallLength(wall, style)
 //	Places a wall with wall elements attached to another like determined by WallElement properties.
 //
 //	startX, startY  Where the first wall element should be placed
-//	wall            Array of wall element type strings. Example: ["endLeft", "wallLong", "tower", "wallLong", "endRight"]
+//	wall            Array of wall element types. Example: ["start", "long", "tower", "long", "end"]
 //	style           Optional. Wall style string. Default is the civ of the given player, "palisades" for gaia
 //	playerId        Optional. Number of the player the wall will be placed for. Default is 0 (gaia)
 //	orientation     Optional. Angle the first wall element is placed. Default is 0
@@ -435,29 +462,20 @@ function getWallLength(wall, style)
 //	                It will then be build towards top/positive Y (if no bending wall elements like corners are used)
 //	                Raising orientation means the wall is rotated counter-clockwise like placeObject
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function placeWall(startX, startY, wall, style, playerId, orientation)
+function placeWall(startX=0, startY=0, wall=[], style, playerId=0, orientation=0)
 {
-	// Graciously handle arguments
-	if (wall === undefined)
-		wall = [];
-	playerId = (playerId || 0);
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		if (playerId == 0)
-			style = (style || "palisades");
-		else
-			style = (getCivCode(playerId-1));
-	}
-	orientation = (orientation || 0);
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
 	
 	// Get wall alignment
 	var AM = getWallAlignment(startX, startY, wall, style, orientation);
+	
 	// Place the wall
-	for (var iWall = 0; iWall < wall.length; iWall++)
+	for (var iWall = 0; iWall < wall.length; ++iWall)
 	{
-		var entity = AM[iWall].entity;
-		if (entity !== undefined)
-			placeObject(AM[iWall].x, AM[iWall].y, entity, playerId, AM[iWall].angle);
+		var entPath = AM[iWall].entPath;
+		if (entPath !== undefined)
+			placeObject(AM[iWall].x, AM[iWall].y, entPath, playerId, AM[iWall].angle);
 	}
 }
 
@@ -472,19 +490,12 @@ function placeWall(startX, startY, wall, style, playerId, orientation)
 //	playerId       Optional. Number of the player the wall will be placed for. Default is 0 (gaia)
 //	orientation    Optional. Angle the first wall element (should be a gate or entrance) is placed. Default is 0
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function placeCustomFortress(centerX, centerY, fortress, style, playerId, orientation)
+function placeCustomFortress(centerX, centerY, fortress, style, playerId=0, orientation=0)
 {
 	// Graciously handle arguments
-	fortress = (fortress || fortressTypes["medium"]);
-	playerId = (playerId || 0);
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		if (playerId == 0)
-			style = (style || "palisades");
-		else
-			style = (getCivCode(playerId-1));
-	}
-	orientation = (orientation || 0);
+	fortress = fortress || g_FortressTypes["medium"];
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
 	
 	// Calculate center if fortress.centerToFirstElement is undefined (default)
 	var centerToFirstElement = fortress.centerToFirstElement;
@@ -501,22 +512,14 @@ function placeCustomFortress(centerX, centerY, fortress, style, playerId, orient
 //
 //	Like placeCustomFortress just it takes type (a fortress type string, has to be in fortressTypes) instead of an instance of Fortress
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function placeFortress(centerX, centerY, type, style, playerId, orientation)
+function placeFortress(centerX, centerY, type="medium", style, playerId=0, orientation=0)
 {
 	// Graciously handle arguments
-	type = (type || "medium");
-	playerId = (playerId || 0);
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		if (playerId == 0)
-			style = (style || "palisades");
-		else
-			style = (getCivCode(playerId-1));
-	}
-	orientation = (orientation || 0);
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
 	
 	// Call placeCustomFortress with the given arguments
-	placeCustomFortress(centerX, centerY, fortressTypes[type], style, playerId, orientation);
+	placeCustomFortress(centerX, centerY, g_FortressTypes[type], style, playerId, orientation);
 }
 
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
@@ -526,83 +529,79 @@ function placeFortress(centerX, centerY, type, style, playerId, orientation)
 //
 //	startX/startY    Coordinate of the approximate beginning of the wall (Not the place of the first wall element)
 //	targetX/targetY  Coordinate of the approximate ending of the wall (Not the place of the last wall element)
-//	wallPart         Optional. An array of NON-BENDING wall element type strings. Default is ["tower", "wallLong"]
+//	wallPart         Optional. An array of NON-BENDING wall element types. Default is ["tower", "wallLong"]
 //	style            Optional. Wall style string. Default is the civ of the given player, "palisades" for gaia
 //	playerId         Optional. Integer number of the player. Default is 0 (gaia)
 //	endWithFirst     Optional. A boolean value. If true the 1st wall element in the wallPart array will finalize the wall. Default is true
 //
 //	TODO: Maybe add angle offset for more generic looking?
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function placeLinearWall(startX, startY, targetX, targetY, wallPart, style, playerId, endWithFirst)
+function placeLinearWall(startX, startY, targetX, targetY, wallPart, style, playerId=0, endWithFirst=true)
 {
 	// Setup optional arguments to the default
-	wallPart = (wallPart || ["tower", "wallLong"]);
-	playerId = (playerId || 0);
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		if (playerId == 0)
-			style = (style || "palisades");
-		else
-			style = (getCivCode(playerId-1));
-	}
-	endWithFirst = typeof endWithFirst == "undefined" ? true : endWithFirst;
+	wallPart = wallPart || ["tower", "long"];
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
 	
 	// Check arguments
-	for (var elementIndex = 0; elementIndex < wallPart.length; elementIndex++)
-	{
-		var bending = wallStyles[style][wallPart[elementIndex]].bending;
-		if (bending != 0)
-			warn("Bending is not supported by placeLinearWall but a bending wall element is used: " + wallPart[elementIndex] + " -> wallStyles[style][wallPart[elementIndex]].entity");
-	}
+	for (let element of wallPart)
+		if (getWallElement(style, element).bend != 0)
+			warn("Bending is not supported by placeLinearWall but the following bending wall element was used: " + element);
+
 	// Setup number of wall parts
 	var totalLength = getDistance(startX, startY, targetX, targetY);
-	var wallPartLength = 0;
-	for (var elementIndex = 0; elementIndex < wallPart.length; elementIndex++)
-		wallPartLength += wallStyles[style][wallPart[elementIndex]].width;
+	var wallPartLength = getWallLength(style, wallPart);
 	var numParts = 0;
 	if (endWithFirst == true)
-		numParts = ceil((totalLength - wallStyles[style][wallPart[0]].width) / wallPartLength);
+		numParts = ceil((totalLength - getWallElement(style, wallPart[0]).length) / wallPartLength);
 	else
 		numParts = ceil(totalLength / wallPartLength);
+
 	// Setup scale factor
 	var scaleFactor = 1;
 	if (endWithFirst == true)
-		scaleFactor = totalLength / (numParts * wallPartLength + wallStyles[style][wallPart[0]].width);
+		scaleFactor = totalLength / (numParts * wallPartLength + getWallElement(style, wallPart[0]).length);
 	else
 		scaleFactor = totalLength / (numParts * wallPartLength);
+
 	// Setup angle
 	var wallAngle = getAngle(startX, startY, targetX, targetY); // NOTE: function "getAngle()" is about to be changed...
 	var placeAngle = wallAngle - PI/2;
 	// Place wall entities
 	var x = startX;
 	var y = startY;
-	for (var partIndex = 0; partIndex < numParts; partIndex++)
+	for (var partIndex = 0; partIndex < numParts; ++partIndex)
 	{
-		for (var elementIndex = 0; elementIndex < wallPart.length; elementIndex++)
+		for (var elementIndex = 0; elementIndex < wallPart.length; ++elementIndex)
 		{
-			var wallEle = wallStyles[style][wallPart[elementIndex]];
-			// Width correction
-			x += scaleFactor * wallEle.width/2 * cos(wallAngle);
-			y += scaleFactor * wallEle.width/2 * sin(wallAngle);
+			let wallEle = getWallElement(style, wallPart[elementIndex]);
+			let wallLength = (wallEle.length - getOverlap(style)) / 2;
+			let distX = scaleFactor * wallLength * cos(wallAngle);
+			let distY = scaleFactor * wallLength * sin(wallAngle);
+			// Length correction
+			x += distX;
+			y += distY;
 			// Indent correction
-			var placeX = x - wallEle.indent * sin(wallAngle);
-			var placeY = y + wallEle.indent * cos(wallAngle);
+			let placeX = x - wallEle.indent * sin(wallAngle);
+			let placeY = y + wallEle.indent * cos(wallAngle);
 			// Placement
-			var entity = wallEle.entity;
-			if (entity !== undefined)
-				placeObject(placeX, placeY, entity, playerId, placeAngle + wallEle.angle);
-			x += scaleFactor * wallEle.width/2 * cos(wallAngle);
-			y += scaleFactor * wallEle.width/2 * sin(wallAngle);
+			let entPath = wallEle.entPath;
+			if (entPath !== undefined)
+				placeObject(placeX, placeY, entPath, playerId, placeAngle + wallEle.angle);
+			// Prep for next object
+			x += distX;
+			y += distY;
 		}
 	}
 	if (endWithFirst == true)
 	{
-		var wallEle = wallStyles[style][wallPart[0]];
-		x += scaleFactor * wallEle.width/2 * cos(wallAngle);
-		y += scaleFactor * wallEle.width/2 * sin(wallAngle);
-		var entity = wallEle.entity;
-		if (entity !== undefined)
-			placeObject(x, y, entity, playerId, placeAngle + wallEle.angle);
+		var wallEle = getWallElement(style, wallPart[0]);
+		let wallLength = (wallEle.length - getOverlap(style)) / 2;
+		x += scaleFactor * wallLength * cos(wallAngle);
+		y += scaleFactor * wallLength * sin(wallAngle);
+		var entPath = wallEle.entPath;
+		if (entPath !== undefined)
+			placeObject(x, y, entPath, playerId, placeAngle + wallEle.angle);
 	}
 }
 
@@ -615,7 +614,7 @@ function placeLinearWall(startX, startY, targetX, targetY, wallPart, style, play
 //
 //	centerX/Y     Coordinates of the circle's center
 //	radius        How wide the circle should be (approximate, especially if maxBendOff != 0)
-//	wallPart      Optional. An array of NON-BENDING wall element type strings. Default is ["tower", "wallLong"]
+//	wallPart      Optional. An array of NON-BENDING wall element types. Default is ["tower", "wallLong"]
 //	style         Optional. Wall style string. Default is the civ of the given player, "palisades" for gaia
 //	playerId      Optional. Integer number of the player. Default is 0 (gaia)
 //	orientation   Optional. Where the open part of the (circular) arc should face (if maxAngle is < 2*PI). Default is 0
@@ -624,50 +623,38 @@ function placeLinearWall(startX, startY, targetX, targetY, wallPart, style, play
 //	maxBendOff    Optional. How irregular the circle should be. 0 means regular circle, PI/2 means very irregular. Default is 0 (regular circle)
 //
 //	NOTE: Don't use wall elements with bending like corners!
-//	TODO: Perhaps add eccentricity and maxBendOff functionality (untill now an unused argument)
+//	TODO: Perhaps add eccentricity
+//	TODO: Check if maxBendOff parameter works in all cases
 //	TODO: Perhaps add functionality for spirals
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function placeCircularWall(centerX, centerY, radius, wallPart, style, playerId, orientation, maxAngle, endWithFirst, maxBendOff)
+function placeCircularWall(centerX, centerY, radius, wallPart, style, playerId=0, orientation=0, maxAngle=TWO_PI, endWithFirst, maxBendOff=0)
 {
 	// Setup optional arguments to the default
-	wallPart = (wallPart || ["tower", "wallLong"]);
-	playerId = (playerId || 0);
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		if (playerId == 0)
-			style = (style || "palisades");
-		else
-			style = (getCivCode(playerId-1));
-	}
-	orientation = (orientation || 0);
-	maxAngle = (maxAngle || 2*PI);
+	wallPart = wallPart || ["tower", "long"];
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
 	if (endWithFirst === undefined)
 	{
-		if (maxAngle >= 2*PI - 0.001) // Can this be done better?
+		if (maxAngle >= TWO_PI - 0.001) // Can this be done better?
 			endWithFirst = false;
 		else
 			endWithFirst = true;
 	}
-	maxBendOff = (maxBendOff || 0);
 	
 	// Check arguments
 	if (maxBendOff > PI/2 || maxBendOff < 0)
-		warn("placeCircularWall maxBendOff sould satisfy 0 < maxBendOff < PI/2 (~1.5) but it is: " + maxBendOff);
-	for (var elementIndex = 0; elementIndex < wallPart.length; elementIndex++)
-	{
-		var bending = wallStyles[style][wallPart[elementIndex]].bending;
-		if (bending != 0)
-			warn("Bending is not supported by placeCircularWall but a bending wall element is used: " + wallPart[elementIndex]);
-	}
+		warn("placeCircularWall maxBendOff should satisfy 0 < maxBendOff < PI/2 (~1.5) but it is: " + maxBendOff);
+	for (let element of wallPart)
+		if (getWallElement(style, element).bend != 0)
+			warn("Bending is not supported by placeCircularWall but the following bending wall element was used: " + element);
+
 	// Setup number of wall parts
 	var totalLength = maxAngle * radius;
-	var wallPartLength = 0;
-	for (var elementIndex = 0; elementIndex < wallPart.length; elementIndex++)
-		wallPartLength += wallStyles[style][wallPart[elementIndex]].width;
+	var wallPartLength = getWallLength(style, wallPart);
 	var numParts = 0;
 	if (endWithFirst == true)
 	{
-		numParts = ceil((totalLength - wallStyles[style][wallPart[0]].width) / wallPartLength);
+		numParts = ceil((totalLength - getWallElement(style, wallPart[0]).length) / wallPartLength);
 	}
 	else
 	{
@@ -676,32 +663,32 @@ function placeCircularWall(centerX, centerY, radius, wallPart, style, playerId,
 	// Setup scale factor
 	var scaleFactor = 1;
 	if (endWithFirst == true)
-		scaleFactor = totalLength / (numParts * wallPartLength + wallStyles[style][wallPart[0]].width);
+		scaleFactor = totalLength / (numParts * wallPartLength + getWallElement(style, wallPart[0]).length);
 	else
 		scaleFactor = totalLength / (numParts * wallPartLength);
 	// Place wall entities
 	var actualAngle = orientation + (2*PI - maxAngle) / 2;
 	var x = centerX + radius*cos(actualAngle);
 	var y = centerY + radius*sin(actualAngle);
-	for (var partIndex = 0; partIndex < numParts; partIndex++)
+	for (let partIndex = 0; partIndex < numParts; ++partIndex)
 	{
-		for (var elementIndex = 0; elementIndex < wallPart.length; elementIndex++)
+		for (let wallEle of wallPart)
 		{
-			var wallEle = wallStyles[style][wallPart[elementIndex]];
+			wallEle = getWallElement(style, wallEle);
 			// Width correction
-			var addAngle = scaleFactor * wallEle.width / radius;
-			var targetX = centerX + radius * cos(actualAngle + addAngle);
-			var targetY = centerY + radius * sin(actualAngle + addAngle);
-			var placeX = x + (targetX - x)/2;
-			var placeY = y + (targetY - y)/2;
-			var placeAngle = actualAngle + addAngle/2;
+			let addAngle = scaleFactor * (wallEle.length - getOverlap(style)) / radius;
+			let targetX = centerX + radius * cos(actualAngle + addAngle);
+			let targetY = centerY + radius * sin(actualAngle + addAngle);
+			let placeX = x + (targetX - x)/2;
+			let placeY = y + (targetY - y)/2;
+			let placeAngle = actualAngle + addAngle/2;
 			// Indent correction
 			placeX -= wallEle.indent * cos(placeAngle);
 			placeY -= wallEle.indent * sin(placeAngle);
 			// Placement
-			var entity = wallEle.entity;
-			if (entity !== undefined)
-				placeObject(placeX, placeY, entity, playerId, placeAngle + wallEle.angle);
+			var entPath = wallEle.entPath;
+			if (entPath !== undefined)
+				placeObject(placeX, placeY, entPath, playerId, placeAngle + wallEle.angle);
 			// Prepare for the next wall element
 			actualAngle += addAngle;
 			x = centerX + radius*cos(actualAngle);
@@ -710,14 +697,14 @@ function placeCircularWall(centerX, centerY, radius, wallPart, style, playerId,
 	}
 	if (endWithFirst == true)
 	{
-		var wallEle = wallStyles[style][wallPart[0]];
-		var addAngle = scaleFactor * wallEle.width / radius;
+		var wallEle = getWallElement(style, wallPart[0]);
+		var addAngle = scaleFactor * wallEle.length / radius;
 		var targetX = centerX + radius * cos(actualAngle + addAngle);
 		var targetY = centerY + radius * sin(actualAngle + addAngle);
 		var placeX = x + (targetX - x)/2;
 		var placeY = y + (targetY - y)/2;
 		var placeAngle = actualAngle + addAngle/2;
-		placeObject(placeX, placeY, wallEle.entity, playerId, placeAngle + wallEle.angle);
+		placeObject(placeX, placeY, wallEle.entPath, playerId, placeAngle + wallEle.angle);
 	}
 }
 
@@ -728,7 +715,7 @@ function placeCircularWall(centerX, centerY, radius, wallPart, style, playerId,
 //
 //	centerX/Y          Coordinates of the polygon's center
 //	radius             How wide the circle should be in which the polygon fits
-//	wallPart           Optional. An array of NON-BENDING wall element type strings. Default is ["wallLong", "tower"]
+//	wallPart           Optional. An array of NON-BENDING wall element types. Default is ["wallLong", "tower"]
 //	cornerWallElement  Optional. Wall element to be placed at the polygon's corners. Default is "tower"
 //	style              Optional. Wall style string. Default is the civ of the given player, "palisades" for gaia
 //	playerId           Optional. Integer number of the player. Default is 0 (gaia)
@@ -741,43 +728,40 @@ function placeCircularWall(centerX, centerY, radius, wallPart, style, playerId,
 //	TODO: Check some arguments
 //	TODO: Add eccentricity and perhaps make it just call placeIrregularPolygonalWall with irregularity = 0
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function placePolygonalWall(centerX, centerY, radius, wallPart, cornerWallElement, style, playerId, orientation, numCorners, skipFirstWall)
+function placePolygonalWall(centerX, centerY, radius, wallPart, cornerWallElement, style, playerId=0, orientation=0, numCorners=8, skipFirstWall=true)
 {
 	// Setup optional arguments to the default
-	wallPart = (wallPart || ["wallLong", "tower"]);
-	cornerWallElement = (cornerWallElement || "tower"); // Don't use wide elements for this. Not supported well...
-	playerId = (playerId || 0);
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		if (playerId == 0)
-			style = (style || "palisades");
-		else
-			style = (getCivCode(playerId-1));
-	}
-	orientation = (orientation || 0);
-	numCorners = (numCorners || 8);
-	skipFirstWall = (skipFirstWall || true);
-	
+	wallPart = wallPart || ["long", "tower"];
+	cornerWallElement = cornerWallElement || "tower"; // Don't use wide elements for this. Not supported well...
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
+
 	// Setup angles
-	var angleAdd = 2*PI/numCorners;
+	var angleAdd = TWO_PI/numCorners;
 	var angleStart = orientation - angleAdd/2;
+
 	// Setup corners
 	var corners = [];
-	for (var i = 0; i < numCorners; i++)
+	for (let i = 0; i < numCorners; ++i)
 		corners.push([centerX + radius*cos(angleStart + i*angleAdd), centerY + radius*sin(angleStart + i*angleAdd)]);
+
 	// Place Corners and walls
-	for (var i = 0; i < numCorners; i++)
+	for (let i = 0; i < numCorners; ++i)
 	{
-		var angleToCorner = getAngle(corners[i][0], corners[i][1], centerX, centerY);
-		placeObject(corners[i][0], corners[i][1], wallStyles[style][cornerWallElement].entity, playerId, angleToCorner);
+		let angleToCorner = getAngle(corners[i][0], corners[i][1], centerX, centerY);
+		placeObject(corners[i][0], corners[i][1], getWallElement(style, cornerWallElement).entPath, playerId, angleToCorner);
 		if (!(skipFirstWall && i == 0))
 		{
+			let cornerLength = getWallElement(style, cornerWallElement).length / 2;
+			let cornerAngle = angleToCorner + angleAdd / 2;
+			let cornerX = cornerLength * sin(cornerAngle);
+			let cornerY = cornerLength * cos(cornerAngle);
 			placeLinearWall(
 				// Adjustment to the corner element width (approximately)
-				corners[i][0] + wallStyles[style][cornerWallElement].width/2 * sin(angleToCorner + angleAdd/2), // startX
-				corners[i][1] - wallStyles[style][cornerWallElement].width/2 * cos(angleToCorner + angleAdd/2), // startY
-				corners[(i+1)%numCorners][0] - wallStyles[style][cornerWallElement].width/2 * sin(angleToCorner + angleAdd/2), // targetX
-				corners[(i+1)%numCorners][1] + wallStyles[style][cornerWallElement].width/2 * cos(angleToCorner + angleAdd/2), // targetY
+				corners[i][0] + cornerX, // startX
+				corners[i][1] - cornerY, // startY
+				corners[(i+1)%numCorners][0] - cornerX, // targetX
+				corners[(i+1)%numCorners][1] + cornerY, // targetY
 				wallPart, style, playerId);
 		}
 	}
@@ -794,9 +778,9 @@ function placePolygonalWall(centerX, centerY, radius, wallPart, cornerWallElemen
 //	style                Optional. Wall style string. Default is the civ of the given player, "palisades" for gaia
 //	playerId             Optional. Integer number of the player. Default is 0 (gaia)
 //	orientation          Optional. Angle from the center to the first linear wall part placed. Default is 0 (towards positive X/right)
-//	numCorners           Optional. How many corners the polygon will have. Default is 8 (matching a civ centers territory)
+//	numCorners           Optional. How many corners the polygon will have. Default is randomly chosen from 'tween 5 & 7 inclusive
 //	irregularity         Optional. How irregular the polygon will be. 0 means regular, 1 means VERY irregular. Default is 0.5
-//	skipFirstWall        Optional. Boolean. If the first linear wall part will be left opened as entrance. Default is true
+//	skipFirstWall        Optional. Boolean. If the first linear wall part will be left opened as entrance. Default is false
 //	wallPartsAssortment  Optional. An array of wall part arrays to choose from for each linear wall connecting the corners. Default is hard to describe ^^
 //
 //	NOTE: wallPartsAssortment is put to the end because it's hardest to set
@@ -805,28 +789,23 @@ function placePolygonalWall(centerX, centerY, radius, wallPart, cornerWallElemen
 //	TODO: Check some arguments
 //	TODO: Perhaps add eccentricity
 ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function placeIrregularPolygonalWall(centerX, centerY, radius, cornerWallElement, style, playerId, orientation, numCorners, irregularity, skipFirstWall, wallPartsAssortment)
+function placeIrregularPolygonalWall(centerX, centerY, radius, cornerWallElement="tower", style, playerId=0, orientation=0, numCorners, irregularity=0.5, skipFirstWall=false, wallPartsAssortment)
 {
 	// Setup optional arguments
-	playerId = (playerId || 0);
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		if (playerId == 0)
-			style = (style || "palisades");
-		else
-			style = (getCivCode(playerId-1));
-	}
-	
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
+	numCorners = (numCorners || randInt(5, 7));
+
 	// Generating a generic wall part assortment with each wall part including 1 gate lengthened by walls and towers
 	// NOTE: It might be a good idea to write an own function for that...
-	var defaultWallPartsAssortment = [["wallShort"], ["wall"], ["wallLong"], ["gate", "tower", "wallShort"]];
+	var defaultWallPartsAssortment = [["short"], ["medium"], ["long"], ["gate", "tower", "short"]];
 	var centeredWallPart = ["gate"];
-	var extandingWallPartAssortment = [["tower", "wallLong"], ["tower", "wall"]];
+	var extandingWallPartAssortment = [["tower", "long"], ["tower", "medium"]];
 	defaultWallPartsAssortment.push(centeredWallPart);
-	for (var i = 0; i < extandingWallPartAssortment.length; i++)
+	for (var i = 0; i < extandingWallPartAssortment.length; ++i)
 	{
 		var wallPart = centeredWallPart;
-		for (var j = 0; j < radius; j++)
+		for (var j = 0; j < radius; ++j)
 		{
 			if (j%2 == 0)
 				wallPart = wallPart.concat(extandingWallPartAssortment[i]);
@@ -841,17 +820,11 @@ function placeIrregularPolygonalWall(centerX, centerY, radius, cornerWallElement
 	}
 	// Setup optional arguments to the default
 	wallPartsAssortment = (wallPartsAssortment || defaultWallPartsAssortment);
-	cornerWallElement = (cornerWallElement || "tower"); // Don't use wide elements for this. Not supported well...
-	style = (style || "palisades");
-	playerId = (playerId || 0);
-	orientation = (orientation || 0);
-	numCorners = (numCorners || randInt(5, 7));
-	irregularity = (irregularity || 0.5);
-	skipFirstWall = (skipFirstWall || false);
+
 	// Setup angles
-	var angleToCover = 2*PI;
+	var angleToCover = TWO_PI;
 	var angleAddList = [];
-	for (var i = 0; i < numCorners; i++)
+	for (var i = 0; i < numCorners; ++i)
 	{
 		// Randomize covered angles. Variety scales down with raising angle though...
 		angleAddList.push(angleToCover/(numCorners-i) * (1 + randFloat(-irregularity, irregularity)));
@@ -860,7 +833,7 @@ function placeIrregularPolygonalWall(centerX, centerY, radius, cornerWallElement
 	// Setup corners
 	var corners = [];
 	var angleActual = orientation - angleAddList[0]/2;
-	for (var i = 0; i < numCorners; i++)
+	for (var i = 0; i < numCorners; ++i)
 	{
 		corners.push([centerX + radius*cos(angleActual), centerY + radius*sin(angleActual)]);
 		if (i < numCorners - 1)
@@ -869,22 +842,23 @@ function placeIrregularPolygonalWall(centerX, centerY, radius, cornerWallElement
 	// Setup best wall parts for the different walls (a bit confusing naming...)
 	var wallPartLengths = [];
 	var maxWallPartLength = 0;
-	for (var partIndex = 0; partIndex < wallPartsAssortment.length; partIndex++)
+	for (let wallPart of wallPartsAssortment)
 	{
-		var length = wallPartLengths[partIndex];
-		wallPartLengths.push(getWallLength(wallPartsAssortment[partIndex], style));
+		var length = getWallLength(style, wallPart);
+		wallPartLengths.push(length);
 		if (length > maxWallPartLength)
 			maxWallPartLength = length;
 	}
+	
 	var wallPartList = []; // This is the list of the wall parts to use for the walls between the corners, not to confuse with wallPartsAssortment!
-	for (var i = 0; i < numCorners; i++)
+	for (var i = 0; i < numCorners; ++i)
 	{
-		var bestWallPart = []; // This is a simpel wall part not a wallPartsAssortment!
-		var bestWallLength = 99999999;
+		var bestWallPart = []; // This is a simple wall part not a wallPartsAssortment!
+		var bestWallLength = Number.MAX_VALUE;
 		// NOTE: This is not exactly like the length the wall will be in the end. Has to be tweaked...
 		var wallLength = getDistance(corners[i][0], corners[i][1], corners[(i+1)%numCorners][0], corners[(i+1)%numCorners][1]);
 		var numWallParts = ceil(wallLength/maxWallPartLength);
-		for (var partIndex = 0; partIndex < wallPartsAssortment.length; partIndex++)
+		for (var partIndex = 0; partIndex < wallPartsAssortment.length; ++partIndex)
 		{
 			var linearWallLength = numWallParts*wallPartLengths[partIndex];
 			if (linearWallLength < bestWallLength && linearWallLength > wallLength)
@@ -895,19 +869,21 @@ function placeIrregularPolygonalWall(centerX, centerY, radius, cornerWallElement
 		}
 		wallPartList.push(bestWallPart);
 	}
+
 	// Place Corners and walls
-	for (var i = 0; i < numCorners; i++)
+	for (var i = 0; i < numCorners; ++i)
 	{
 		var angleToCorner = getAngle(corners[i][0], corners[i][1], centerX, centerY);
-		placeObject(corners[i][0], corners[i][1], wallStyles[style][cornerWallElement].entity, playerId, angleToCorner);
+		placeObject(corners[i][0], corners[i][1], getWallElement(style, cornerWallElement).entPath, playerId, angleToCorner);
 		if (!(skipFirstWall && i == 0))
 		{
+			let cornerLength = getWallElement(style, cornerWallElement).length / 2;
 			placeLinearWall(
 				// Adjustment to the corner element width (approximately)
-				corners[i][0] + wallStyles[style][cornerWallElement].width/2 * sin(angleToCorner + angleAddList[i]/2), // startX
-				corners[i][1] - wallStyles[style][cornerWallElement].width/2 * cos(angleToCorner + angleAddList[i]/2), // startY
-				corners[(i+1)%numCorners][0] - wallStyles[style][cornerWallElement].width/2 * sin(angleToCorner + angleAddList[(i+1)%numCorners]/2), // targetX
-				corners[(i+1)%numCorners][1] + wallStyles[style][cornerWallElement].width/2 * cos(angleToCorner + angleAddList[(i+1)%numCorners]/2), // targetY
+				corners[i][0] + cornerLength * sin(angleToCorner + angleAddList[i]/2), // startX
+				corners[i][1] - cornerLength * cos(angleToCorner + angleAddList[i]/2), // startY
+				corners[(i+1)%numCorners][0] - cornerLength * sin(angleToCorner + angleAddList[(i+1)%numCorners]/2), // targetX
+				corners[(i+1)%numCorners][1] + cornerLength * cos(angleToCorner + angleAddList[(i+1)%numCorners]/2), // targetY
 				wallPartList[i], style, playerId, false);
 		}
 	}
